#pragma once


#ifndef MGML_GUARDIAN
	#include "../CSL/MGML.h"
#endif

using namespace MGML;

enum {MAX_DEEP = 1, CELL_NUMBER = 8};

struct GridCell
{
  unsigned int leftOffset: 31;
  unsigned int leaf : 1;
};

struct HGridNode
{
  HGridNode() 
    { upOffset = -1;}
  
  bool Empty() 
    {return upOffset == -1;}

  void Draw();

  AABB2f m_box;
  uint upOffset;
  GridCell grid[CELL_NUMBER*CELL_NUMBER];
};


class HierarchicalGrid2D
{
public:

  HierarchicalGrid2D();
  ~HierarchicalGrid2D();

  int Build(const AABB2f& in_box, int prevOffset, int currDeep);
  void Draw();

  const AABB2f& GetBox(int offset);

protected:
  HierarchicalGrid2D(const HierarchicalGrid2D& rhs) {}
  HierarchicalGrid2D& operator=(const HierarchicalGrid2D& rhs) {return *this;}

  enum {T_SZ = CELL_NUMBER*CELL_NUMBER};
  enum {MAX_TREE_SIZE = T_SZ + T_SZ*T_SZ + T_SZ*T_SZ*T_SZ};
 
  HGridNode *nodes;
  int m_top;
};






/////////////////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////////////////

