#include "Input.h"

void Input::Mouse(int button, int state, int x, int y) //  
{
	if (button==GLUT_LEFT_BUTTON)		// 
	{
		switch (state)
		{
			case GLUT_DOWN:		// 
				ldown=true;		// 
				mx=x;			// 
				my=y;
				break;
			case GLUT_UP:
				ldown=false;
				break;
		}
	}

	if (button==GLUT_RIGHT_BUTTON)	// 
	{
		switch (state)
		{
			case GLUT_DOWN:
				rdown=true;
				mx=x;
				my=y;
				break;
			case GLUT_UP:
				rdown=false;
				break;
		}
	}
}

void Input::MouseMotion(int x, int y)                  // 
{
    if(ldown)		//  
	{
		cam_rot.M[0]+=0.1*(y-my);	//  
		cam_rot.M[1]+=0.1*(x-mx);
		mx=x;
		my=y;
	}

	if (rdown)	//
	{
//		global_translate.M[0]+=0.01*(x-mx);	//   
//		if (tt)
//			global_translate.M[2]+=0.01*(y-my);
//		else
//			global_translate.M[1]+=0.01*(my-y);
		mx=x;
		my=y;
	}
}


void Input::Keyboard(unsigned char key, int x, int y)
{

	switch(key)
	{
	case VK_ESCAPE:
		exit_status = true;
	break;
	
	case 'q':
	case 'Q':
		cam_rot.z() -= 10;
	break;
		
	case 'e':
	case 'E':
		cam_rot.z() += 10;
	break;

	case 'w':
	case 'W':
		cam_mov.z() = -0.1;
	break;
	
	case 's':
	case 'S':
		cam_mov.z() = 0.1;
	break;

	case 'a':
	case 'A':
		cam_mov.x() = -0.1;
	break;

	case 'd':
	case 'D':
		cam_mov.x() = 0.1;
	break;

	case 'r':
	case 'R':
		cam_mov.y() = 0.1;
	break;

	case 'f':
	case 'F':
		cam_mov.y() = -0.1;
	break;

	case ' ':
		spacePressed = true;
		break;



	case '1':
		trace_depth=1;
	break;

	case '2':
		trace_depth=2;
	break;

	case '3':
		trace_depth=3;
	break;

	case '4':
		trace_depth=4;
	break;

	case '5':
		trace_depth=5;
	break;

	case 'Z':
	case 'z':
		shadows=!shadows;
	break;
	}
}

void Input::KeyboardSpecial(int key, int x, int y)
{
	switch(key)
	{
	case GLUT_KEY_LEFT:
		changeCannonPhi = -0.025f;
		break;

	case GLUT_KEY_RIGHT:
		changeCannonPhi = 0.025f;
		break;

	case GLUT_KEY_UP:
		changeCannonTheta = 0.025f;
		break;

	case GLUT_KEY_DOWN:
		changeCannonTheta = -0.025f;
		break;

	case GLUT_KEY_PAGE_UP:
		changeCannonStartVel = 10;
		break;

	case GLUT_KEY_PAGE_DOWN:
		changeCannonStartVel = -10;
		break;
	};
}

void Input::reset()
{
	cam_mov.set(0,0,0,1);
	changeCannonPhi = 0;
	changeCannonTheta = 0;
	changeCannonStartVel = 0;
	spacePressed = false;
}